<?php
require_once('../Smarty/Smarty.class.php');
require_once('Net/UserAgent/Mobile.php');
require_once('emoji.php');

class Smarty_Mobile extends Smarty {
	protected $emoji = null;
	protected $agent = null;
	protected $carrier = '';
	public $template_dir = 'templates';// SmartyNXŎgp郁oϐB
	public $compile_dir = 'templates_c';// SmartyNXŎgp郁oϐB
	public $cache_dir = 'cache';// SmartyNXŎgp郁oϐB

	protected function Smarty_Mobile() {
		$this->agent = Net_UserAgent_Mobile::factory();
		if ($this->agent->isDoCoMo()) {
			$this->emoji = new EmojiDoCoMo();// DoCoMopEmojiCX^X𐶐
			$this->carrier = 'DoCoMo';
		} else if ($this->agent->isVodafone()) {
			$this->emoji = new EmojiSoftBank();// SoftBankpEmojiCX^X𐶐
			$this->carrier = 'SoftBank';
		} else if ($this->agent->isEZweb()) {
			$this->emoji = new EmojiAu();// aupEmojiCX^X𐶐
			$this->carrier = 'Au';
		} else {
			$this->emoji = new EmojiEtc();// ̑pEmojiCX^X𐶐
			$this->carrier = 'Unknown';
		}
		parent::Smarty();// eNX̃RXgN^Ăяo
	}

	public function factory() {
		$smarty = new Smarty_Mobile();
		$smarty->register_block('band', array($smarty, 'smarty_block_band'));// ev[g{band}{/band}gpł悤ɂȂ
		$smarty->register_function('emoji', array($smarty, 'smarty_function_emoji'));// ev[g{emoji}gpł悤ɂȂ
		$smarty->register_outputfilter(array($smarty, 'mobile_outputfilter'));
		$smarty->assign('carrier', $smarty->carrier);
		return $smarty;
	}

	public function mobile_outputfilter($src, $smarty) {
		// LA
		header('Cache-Control: no-cache');
		$head = '';
		if ($this->agent->isDoCoMo()) {
			header('Content-Type: application/xhtml+xml; charset=Shift_JIS');
			$head .= '<?xml version="1.0" encoding="Shift_JIS"?>' . "?n";
			$head .= '<!DOCTYPE html PUBLIC "-//i-mode group (ja)//DTD XHTML i-XHTML(Locale/Ver.=ja/1.0) 1.0//EN" "i-xhtml_4ja_10.dtd">' . "?n";
		} else if ($this->agent->isVodafone()) {
			header('Content-Type: text/html');
			$head .= '<?xml version="1.0" encoding="Shift_JIS"?>' . "?n";
			$head .= '<!DOCTYPE html PUBLIC "-//J-PHONE//DTD XHTML Basic 1.0 Plus//EN" "xhtml-basic10-plus.dtd">' . "?n";
		} else if ($this->agent->isEZweb()) {
			header('Content-Type: text/html');
			$head .= '<?xml version="1.0" encoding="Shift_JIS"?>' . "?n";
			$head .= '<!DOCTYPE html PUBLIC "-//OPENWAVE//DTD XHTML 1.0//EN" "http://www.openwave.com/DTD/xhtml-basic.dtd">' . "?n";
		} else {
			header('Content-Type: text/html');
		}
		// pJiɕϊ
		$src = mb_convert_kana($src, 'ka');
		return $head . $src;
	}

	public function smarty_block_band($params, $content, $smarty, $repeat) {
		$style = '';
		if (isset($params['fontcolor'])) {
			$style .= sprintf('color: %s;', $params['fontcolor']);
		}
		if (isset($params['color'])) {
			$style .= sprintf('background-color: %s;', $params['color']);
		}
		if ($style != '') {
			$style = sprintf(' style="%s"', $style);
		}
		return sprintf('<div%s>%s</div>', $style, $content);
	}

	public function smarty_function_emoji($params, $smarty)
	{
		if (isset($params['name'])) {
			return $this->emoji->getEmojiByName($params['name']);
		}
	}
}
?>
